chiark / gitweb /
Test suite: Move bm-quirk-sbuild-after-act to lib-build-modes
[dgit.git] / tests / lib-build-modes
1
2 bm-prep-ownpackage-branches () {
3         cat <<'END' >$tmp/stunt-git
4 #!/bin/sh -e
5 case "$*" in
6 *clean*) echo >&2 "BUILD-MODES PROGRAM git $*" ;;
7 esac
8 exec git "$@"
9 END
10         chmod +x $tmp/stunt-git
11
12         bm_branches="$1"
13 }
14
15 bm-prep () {
16         t-tstunt-parsechangelog
17
18         t-prep-newpackage example 1.0
19
20         cd $p
21
22         git checkout -b bad-build-deps indep-arch
23         perl -pe 's/Build-Depends.*/$&, x-dgit-no-such-package/' \
24                 -i debian/control
25         git commit -a -m bad-build-deps
26
27         bm-prep-ownpackage-branches 'indep-arch bad-build-deps'
28
29         if zgrep 'dpkg-buildpackage: Make dependency checks fatal for -S' \
30                 /usr/share/doc/dpkg-dev/changelog.gz; then
31                         dpkgbuildpackage_deps_for_clean=true
32         else
33                         dpkgbuildpackage_deps_for_clean=false
34         fi
35
36         cleanmodes_default="git none dpkg-source dpkg-source-d"
37         cleanmodes_all="$cleanmodes_default git-ff check"
38         cleanmodes="$cleanmodes_default"
39 }
40
41 bm-guess-e-source-e-targets () {
42         local some_act=$1
43         case "$some_act" in
44         sbuild*" --no-arch-all"*)
45                 e_source=true;  e_targets='build-arch binary-arch'      ;;
46         build-source)
47                 e_source=true;  e_targets=''                            ;;
48         *" -b") e_source=false; e_targets='build binary'                ;;
49         *" -B") e_source=false; e_targets='build-arch binary-arch'      ;;
50         *" -A") e_source=false; e_targets='build-indep binary-indep'    ;;
51         *" -S") e_source=true;  e_targets=' '                           ;;
52         *" -F") e_source=true;  e_targets='build binary'                ;;
53         *" -G") e_source=true;  e_targets='build-arch binary-arch'      ;;
54         *" -g") e_source=true;  e_targets='build-indep binary-indep'    ;;
55         *)      e_source=true;  e_targets='build binary'                ;;
56         esac
57 }
58
59 bm-quirk-sbuild-after-act () {
60         # sbuild likes to run the package clean target in the chroot,
61         # which isn't necessary in our case.  We don't disable it in
62         # dgit because we want to do what sbuild does, in case there
63         # are packages which don't build unless their clean target was
64         # run.  We know it must be running it in the chroot because we
65         # provide sbuild with the dsc, not the tree, so we simply
66         # ignore all executions of the clean target by schroot.
67         local arch=$(dpkg-architecture -qDEB_BUILD_ARCH)
68         local sblog=../example_1.0_$arch.build
69         if [ -e $sblog ]; then
70                 sed '
71                         s/^EXAMPLE RULES TARGET clean/HOOK SUPPRESSED &/;
72                 ' <$sblog >>$bmlog
73         fi
74 }
75
76 bm-report-source () {
77         if "$@"; then
78                 echo >&4 "SOURCE EXISTS"
79         else
80                 echo >&4 "SOURCE MISSING"
81         fi
82 }
83
84 bm-build-deps-ok () {
85         case "$branch" in
86         *bad-build-deps*)       return 1        ;;
87         *)                      return 0        ;;
88         esac
89 }
90
91 bm-compute-expected () {
92         require_fail=unexpect # or required
93         tolerate_fail=unexpect # or tolerate
94
95         exec 4>$bmexp
96         echo >&4 "$heading"
97
98         case $cleanmode in
99         git)            echo >&4 'BUILD-MODES PROGRAM git clean -xdf' ;;
100         git-ff)         echo >&4 'BUILD-MODES PROGRAM git clean -xdff' ;;
101         check)          echo >&4 'BUILD-MODES PROGRAM git clean -xdn' ;;
102         dpkg-source-d)  echo >&4 "EXAMPLE RULES TARGET clean" ;;
103         dpkg-source)    bm-build-deps-ok || tolerate_fail=tolerate
104                         echo >&4 "EXAMPLE RULES TARGET clean"
105                         ;;
106         none)           ;;
107         *)              fail "t-compute-expected-run $cleanmode ??" ;;
108         esac
109
110         if [ "x$e_targets" != x ]; then
111                 # e_targets can be " " to mean `/may/ fail due to b-d'
112                 bm-build-deps-ok || tolerate_fail=tolerate
113         fi
114
115         for t in $e_targets; do
116                 bm-build-deps-ok || require_fail=required
117                 echo >&4 "EXAMPLE RULES TARGET $t"
118         done
119
120         bm-report-source $e_source
121
122         exec 4>&-
123 }
124
125 bm-run-one () {
126         local args="$DGIT_TEST_BM_BASEARGS --clean=$cleanmode $real_act"
127
128         bmid="$act,$cleanmode,$branch"
129         bmid=${bmid// /_}
130
131         heading="===== [$bmid] dgit $args ====="
132
133         bmlog=$tmp/run.$bmid.output
134         bmexp=$tmp/run.$bmid.expected
135         bmgot=$tmp/run.$bmid.results
136
137         bm-compute-expected
138
139         git checkout $branch
140         git clean -xdf # since we might not do any actual cleaning
141
142         dsc='../example_1.0.dsc'
143         rm -f $dsc
144
145         set +o pipefail
146         t-dgit --rm-old-changes --git=$tmp/stunt-git $args 2>&1 | tee $bmlog
147         local ps="${PIPESTATUS[*]}"
148         set -o pipefail
149
150         $bm_quirk_after_act
151
152         exec 4>$bmgot
153         echo >&4 "$heading"
154
155         case $ps in
156         "0 0")  actual_status=success ;;
157         *" 0")  actual_status=failure; echo >&4 "OPERATION FAILED"; ;;
158         *)      fail "tee failed" ;;
159         esac
160
161         case "$require_fail-$tolerate_fail-$actual_status" in
162         required-********-failure) echo >>$bmexp "REQUIRED FAILURE" ;;
163         ********-tolerate-failure) echo >>$bmexp "TOLERATED FAILURE" ;;
164         unexpect-********-success) ;;
165         *)      fail "RF=$require_fail TF=$tolerate_fail AS=$actual_status" ;;
166         esac
167
168         egrep >&4 '^EXAMPLE RULES TARGET|^BUILD-MODES' $bmlog || [ $? = 1 ]
169
170         bm-report-source [ -e $dsc ]
171
172         exec 4>&-
173
174         $bm_quirk_before_diff
175
176         [ $actual_status = failure ] || diff -U10 $bmexp $bmgot
177 }
178
179 bm-act-iterate () {
180         for cleanmode in $cleanmodes; do
181                 for branch in $bm_branches; do
182                         bm-run-one
183                 done
184         done
185         : bm-act-iterate done.
186 }
187
188 bm-alwayssplit () {
189         local t=${0##*/}
190         DGIT_TEST_BM_BASEARGS+=' --always-split-source-build'
191         export DGIT_TEST_BM_BASEARGS
192         t-chain-test "${t%%-asplit}"
193 }